#include "NodeLinkSlave.h"
#include "NodeLinkCommon.h"
#include "encrypt_xxtea.h"
#include <string.h>


static unsigned char native_data_in_buffer[NATIVE_DATA_BUFFER_SIZE];


/**
 * ñ뻺
 * 
 * @author lxz (041620 15:46:10)
 * 
 * @param slave վ
 * @param buffer 
 * @param total  
 */
void nodelink_slave_set_native_in_buffer(nodelink_slave_t *slave,
                                         unsigned char *buffer,
                                         int total) {
    dh_fifo_init(&slave->native_data_in, buffer, total);
}


/**
 * ʼվϢ
 * 
 * @author lxz (041620 15:28:37)
 * 
 * @param slave  վ
 * @param type 	վ豸 
 * @param ops   վӦ 
 */
void nodelink_slave_init(nodelink_slave_t *slave, unsigned char model, nodelink_slave_ops *ops) {

    memset(slave, 0, sizeof(nodelink_slave_t));
    slave->model = model;
    slave->ops = ops;
    nodelink_slave_set_native_in_buffer(slave, &native_data_in_buffer[0], sizeof(native_data_in_buffer));
}



/**
 * վд 
 *  
 * @author lxz (041620 16:08:23)
 * 
 * @param slave վ
 */
void nodelink_slave_run(nodelink_slave_t *slave) {

    //жϽǷ
    if (slave->recv_ok) {
        if (slave->data_in_count > 0) { //ݽ
            //
            unsigned char id;
            int len = nodelink_decode(&id, slave->data_in, slave->data_in, slave->data_in_count);
            if (len > 0) {
                len = 0;
                //ͨжIDִжӦ
                if (id == 0x00) {
                    //ID
                    if (slave->data_in[0] == 0xA0 && slave->id == 0) {  //IDΪ0ʱӦ0xA0ָ
                        //У鸽У
                        uint32_t key[4] = { 0x00112233, 0x44556677, 0x8899AABB, 0xCCDDEEFF };
                        uint32_t code[4];
                        code[0] = (slave->data_in[1]) | (slave->data_in[2] << 8) | (slave->data_in[3] << 16) | (slave->data_in[4] << 24);
                        code[1] = (slave->data_in[5]) | (slave->data_in[6] << 8) | (slave->data_in[7] << 16) | (slave->data_in[8] << 24);
                        code[2] = (slave->data_in[9]) | (slave->data_in[10] << 8) | (slave->data_in[11] << 16) | (slave->data_in[12] << 24);
                        code[3] = (slave->data_in[13]) | (slave->data_in[14] << 8) | (slave->data_in[15] << 16) | (slave->data_in[16] << 24);
                        xxtea_uint_decrypt(code, 4, key);
                        //IDģʽ
                        slave->status = 0xA0;
                        slave->data_out[len++] = 0xA0;
                        //͵ݽнط
                        memcpy(&slave->data_out[len], code, 16);
                        len += 16;
                    }
                    else if (slave->data_in[0] == 0xA1) {   //IDָʱIDΪ0ʱIDΪָIDʱӦָ
                        if ((slave->status == 0xA0 && slave->id == 0) || slave->id == slave->data_in[1]) {
                            //IDģʽIDͬģʽ£Ӧð
                            slave->status = 0;
                            slave->id = slave->data_in[1];
                            slave->data_out[len++] = slave->data_in[0];
                            slave->data_out[len++] = slave->model;
                            slave->ops->event_handle(NL_SLAVE_EVENT_SETID,slave->id);
                        }
                    }
                }
                else if (id == 0xf0) {
                    //λߣҪӦ

                    slave->id = 0;
                    slave->status = 0x00;
                    slave->ops->event_handle(NL_SLAVE_EVENT_RESET,0);
                }
                else if (id == slave->id) {
                    //豸
                    len = slave->ops->on_deal(&slave->data_out[0], &slave->data_in[0], len);
                }
                if (len > 0) {
                    //жɵ쳣Ҫȸֵ
                    slave->data_in_count = 0;
                    slave->data_out_posi = 0;
                    slave->data_out_count = nodelink_encode(slave->id, &slave->data_out[0], &slave->data_out[0], len);
                }
            }
            else
            {
                slave->ops->event_handle(NL_SLAVE_EVENT_CRCERROR, 0);
            }
            slave->data_in_count = 0;
        }
        slave->recv_ok = 0;
    }
    //ͻݣΪ˴ͣⲿҪже
    nodelink_slave_native_out(slave);
}

/**
 *  ؽһ
 * 
 * @author lxz (041620 16:10:12)
 * 
 * @param slave  վ
 * @param dat    յ
 */
void nodelink_slave_master_in(nodelink_slave_t *slave, unsigned char dat) {
    //ID²ὫλΪ0ת
    id = dat & 0xf0;
    if (id != 0 || slave->id != 0) {
        slave->ops->slave_port_down(dat);
    }
    if (slave->id  == id || id == 0xf0 || id == 0x00) {
        //ԼIDĲԼǰIDͬģŻн
        slave->data_in[slave->data_in_count++] = dat;
    }
}

/**
 * Ӵվյһֽ
 * 
 * @author lxz (041720 19:00:08)
 * 
 * @param slave 
 * @param dat 
 */
void nodelink_slave_slave_in(nodelink_slave_t *slave, unsigned char dat) {
    //оվҪȽfifo
    slave->ops->slave_port_up(dat);
}

/**
 * 
 * 
 * @author lxz (041820 12:07:32)
 * 
 * @param slave 
 */
void nodelink_slave_native_out(nodelink_slave_t *slave) {
    //ִб
    unsigned char dat = 0;
    while (slave->data_out_count > 0) { //ͱ
        dat = slave->data_out[slave->data_out_posi++];
        slave->ops->slave_port_up(dat);
        slave->data_out_count--;
    }
}

/**
 * ֪ͨվ
 * 
 * @author lxz (070120 15:04:27)
 * 
 * @param slave 
 */
void nodelink_slave_recv_ok(nodelink_slave_t *slave) {
    slave->recv_ok = 1;
}

