#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "st_sys.h"

#include "encrypt_md5.h"
#include "encrypt_xxtea.h"
#include "MathHelper.h"

#include "TinyLog.h"
#include "board.h"

#include "software_timer.h"
#include "variable.h"

#include "modbus_encoder.h"
#include "modbus_common.h"
#include "modbus_master.h"
#include "modbus_slave.h"
#include "servocom_app.h"

#include "axis_motion_config.h"
#include "axis_motion.h"
#include "servostep.h"
#include "NodeLinkMaster.h"
#include "nodelink_master_app.h"

#include "AllServoDrv.h"
#include "io_app.h"
#include "extend_master.h"
#include "log_app.h"
#include "modbus_app.h"
#include "poweroff_save_app.h"
#include "user_app.h"
#include "axis_app.h"
#include "IOPinConfig.h"
#include "Action.h"
#include "MachineConfig.h"

//#define USE_EXTEND_INOUTPUT (1)
#define USE_EXTEND_ALARM (1)


#if JING_LONG_MACHINE
    #include "../Machine/JinLongMachine/JLAction.h"
#endif

#if HAI_HUA_MACHINE
  #include "../Machine/HaiHuaMachine/HHChuChiJi.h"
  #include "../Machine/HaiHuaMachine/HHJiaoYaDinCun.h"
  #include "../Machine/HaiHuaMachine/HHQueDuanJi.h"
  #include "../Machine/HaiHuaMachine/HHJinShuDinCun.h"
  #include "../Machine/HaiHuaMachine/HHChuanTouJi.h"
#endif

#if JIN_HONG_MACHINE
    #include "../Machine/JinHongMachine/JHAction.h"
#endif

#if HONG_YE_MACHINE
  #include "../Machine/HongYeMachine/HYChuChiJi.h"
  #include "../Machine/HongYeMachine/HYJiaoYaDinCun.h"
  #include "../Machine/HongYeMachine/HYMXC_NiLong_StepJi.h"
  #include "../Machine/HongYeMachine/HYQueDuanJi.h"
  #include "../Machine/HongYeMachine/HYJinShuDinCun.h"
#endif

#if FU_XIAO_WEI_MACHINE
    #include "../Machine/FuXiaoWeiMachine/FXWAction.h"
#endif
#if FIE_YUE_MACHINE
    #include "../Machine/FeiYueMachine/FeiYueAction.h"
#endif
//һ
#if LONG_YI_MACHINE
    #include "../Machine/LongYiMachine/LongYiAction.h"
#endif

#if CHANG_SHENG_GEI_LI_MACHINE
    #include "../Machine/ChangShengGeiLiMachine/GLAction.h"
#endif

#if YOU_GUAN_MACHINE
  #include "../Machine/YouGuanMachine/YGChuChiJi.h"
  #include "../Machine/YouGuanMachine/YGJiaoYaDinCun.h"
  #include "../Machine/YouGuanMachine/YGDaKong.h"
  #include "../Machine/YouGuanMachine/YGMXC_NiLong_StepJi.h"
  #include "../Machine/YouGuanMachine/YGQueDuanJi.h"
  #include "../Machine/YouGuanMachine/YGJinShuDinCun.h"
  #include "../Machine/YouGuanMachine/YGQueduanChuantou.h"
  #include "../Machine/YouGuanMachine/YGChuanTouJi.h"
#endif

#if ZHEN_YU_MACHINE==1
  #include "../Machine/ZhenYuMachine/ZhenYuAction.h"
#endif

#if JUN_TENG_MACHINE
  #include "../Machine/JunTengMachine/JTChuChiJi.h"
  #include "../Machine/JunTengMachine/JTJiaoYaDinCun.h"
  #include "../Machine/JunTengMachine/JTMXC_NiLong_StepJi.h"
  #include "../Machine/JunTengMachine/JTQueDuanJi.h"
  #include "../Machine/JunTengMachine/JTQueduanChuantou.h"
  #include "../Machine/JunTengMachine/JTDaKong.h"
  #include "../Machine/JunTengMachine/JTTieBuJi.h"
  #include "../Machine/JunTengMachine/JTJinShuDinCun.h"
  #include "../Machine/JunTengMachine/JTChuanTouJi.h"
#endif

#if JIA_CHENG_WEI_YE_MACHINE
  #include "../Machine/JiaChengWeiYeMachine/JCWYChuChiJi.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYJiaoYaDinCun.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYMXC_NiLong_StepJi.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYQueDuanJi.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYQueduanChuantou.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYDaKong.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYTieBuJi.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYJinShuDinCun.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYChuanTouJi.h"
  #include "../Machine/JiaChengWeiYeMachine/JCWYHuaXianJi.h"
#endif

#if XIN_SHENG_MACHINE
  #include "../Machine/XinShengMachine/XSChuChiJi.h"
  #include "../Machine/XinShengMachine/XSJiaoYaDinCun.h"
  #include "../Machine/XinShengMachine/XSMXC_NiLong_StepJi.h"
  #include "../Machine/XinShengMachine/XSQueDuanJi.h"
  #include "../Machine/XinShengMachine/XSQueduanChuantou.h"
  #include "../Machine/XinShengMachine/XSDaKong.h"
  #include "../Machine/XinShengMachine/XSTieBuJi.h"
  #include "../Machine/XinShengMachine/XSJinShuDinCun.h"
  #include "../Machine/XinShengMachine/XSChuanTouJi.h"
#endif

#if WEI_YUAN_SONG_MACHINE
  #include "../Machine/WeiYuanSongMachine/WYSChuChiJi.h"
  #include "../Machine/WeiYuanSongMachine/WYSJiaoYaDinCun.h"
  #include "../Machine/WeiYuanSongMachine/WYSMXC_NiLong_StepJi.h"
  #include "../Machine/WeiYuanSongMachine/WYSQueDuanJi.h"
  #include "../Machine/WeiYuanSongMachine/WYSQueduanChuantou.h"
  #include "../Machine/WeiYuanSongMachine/WYSDaKong.h"
  #include "../Machine/WeiYuanSongMachine/WYSTieBuJi.h"
  #include "../Machine/WeiYuanSongMachine/WYSJinShuDinCun.h"
  #include "../Machine/WeiYuanSongMachine/WYSChuanTouJi.h"
#endif

#if PENG_WEI_CHANG_MACHINE
  #include "../Machine/PengWeiChangMachine/PWCChuChiJi.h"
  #include "../Machine/PengWeiChangMachine/PWCJiaoYaDinCun.h"
  #include "../Machine/PengWeiChangMachine/PWCMXC_NiLong_StepJi.h"
  #include "../Machine/PengWeiChangMachine/PWCQueDuanJi.h"
  #include "../Machine/PengWeiChangMachine/PWCQueduanChuantou.h"
  #include "../Machine/PengWeiChangMachine/PWCDaKong.h"
  #include "../Machine/PengWeiChangMachine/PWCTieBuJi.h"
  #include "../Machine/PengWeiChangMachine/PWCJinShuDinCun.h"
  #include "../Machine/PengWeiChangMachine/PWCChuanTouJi.h"
  #include "../Machine/PengWeiChangMachine/PWCYYaJi.h"
  #include "../Machine/PengWeiChangMachine/PWCJinShuKLShuangSZ.h"
#endif

#if TONG_YONG_MACHINE
  #include "../Machine/TongYongMachine/TYChuChiJi.h"
  #include "../Machine/TongYongMachine/TYJiaoYaDinCun.h"
  #include "../Machine/TongYongMachine/TYMXC_NiLong_StepJi.h"
  #include "../Machine/TongYongMachine/TYQueDuanJi.h"
  #include "../Machine/TongYongMachine/TYQueduanChuantou.h"
  #include "../Machine/TongYongMachine/TYDaKong.h"
  #include "../Machine/TongYongMachine/TYTieBuJi.h"
  #include "../Machine/TongYongMachine/TYJinShuDinCun.h"
  #include "../Machine/TongYongMachine/TYChuanTouJi.h"
  #include "../Machine/TongYongMachine/TYYYaJi.h"
  #include "../Machine/TongYongMachine/TYHeLian.h"
  #include "../Machine/TongYongMachine/TYFangKuaiChaXiao.h"
  #include "../Machine/TongYongMachine/TYHongMenDZJ.h"
#endif

#if XIN_YE_MACHINE
  #include "../Machine/XinYeMachine/XingYeAction.h"
#endif

#if ZHANG_CHUN_YANG_MACHINE
  #include "../Machine/ZhangChunYangMachine/ZCYAction.h"
#endif
#if FJ_YING_XING_MACHINE
  #include "../Machine/YingXingMachine/YingXingAction.h"
#endif

#if Chuan_Chi_MACHINE
    #include "../Machine/ChuanChiMachine/CCAction.h"
#endif
#if XI_DONG_MACHINE
  #include "../Machine/XiDongMachine/XDChuChiJi.h"
  #include "../Machine/XiDongMachine/XDJiaoYaDinCun.h"
  #include "../Machine/XiDongMachine/XDMXC_NiLong_StepJi.h"
  #include "../Machine/XiDongMachine/XDQueDuanJi.h"
  #include "../Machine/XiDongMachine/XDQueduanChuantou.h"
  #include "../Machine/XiDongMachine/XDDaKong.h"
  #include "../Machine/XiDongMachine/XDTieBuJi.h"
  #include "../Machine/XiDongMachine/XDJinShuDinCun.h"
  #include "../Machine/XiDongMachine/XDChuanTouJi.h"
  #include "../Machine/XiDongMachine/XDYYaJi.h"
  #include "../Machine/XiDongMachine/XDSingleYYaJi.h"
  #include "../Machine/XiDongMachine/XDHeLian.h"
  #include "../Machine/XiDongMachine/XDFangKuaiChaXiao.h"
  #include "../Machine/XiDongMachine/XDGongZiMa.h"
  #include "../Machine/XiDongMachine/XDLaSiJi.h"
#endif

#if JU_XING_MACHINE
  #include "../Machine/JuXingMachine/JXChuChiJi.h"
  #include "../Machine/JuXingMachine/JXJiaoYaDinCun.h"
  #include "../Machine/JuXingMachine/JXMXC_NiLong_StepJi.h"
  #include "../Machine/JuXingMachine/JXQueDuanJi.h"
  #include "../Machine/JuXingMachine/JXQueduanChuantou.h"
  #include "../Machine/JuXingMachine/JXDaKong.h"
  #include "../Machine/JuXingMachine/JXTieBuJi.h"
  #include "../Machine/JuXingMachine/JXJinShuDinCun.h"
  #include "../Machine/JuXingMachine/JXChuanTouJi.h"
#endif

#if YU_WEN_XUAN_MACHINE 
    #include "../Machine/YuWenXuanMachine/YuWenXuanAction.h"
#endif
//

#if BRUCE_MACHINE
  #include "../Machine/TongYongMachine/TYChuChiJi.h"
  #include "../Machine/TongYongMachine/TYJiaoYaDinCun.h"
  #include "../Machine/TongYongMachine/TYMXC_NiLong_StepJi.h"
  #include "../Machine/TongYongMachine/TYQueDuanJi.h"
  #include "../Machine/TongYongMachine/TYQueduanChuantou.h"
  #include "../Machine/TongYongMachine/TYDaKong.h"
  #include "../Machine/TongYongMachine/TYTieBuJi.h"
  #include "../Machine/TongYongMachine/TYJinShuDinCun.h"
  #include "../Machine/TongYongMachine/TYChuanTouJi.h"
  #include "../Machine/TongYongMachine/TYYYaJi.h"
  #include "../Machine/TongYongMachine/TYHeLian.h"
  #include "../Machine/TongYongMachine/TYFangKuaiChaXiao.h"
  #include "../Machine/TongYongMachine/TYHongMenDZJ.h"

  #include "../Machine/BruceMachine/BRUCE_DaZheJi.h"
#endif
#if JUN_YUE_MACHINE==1
  #include "../Machine/JunYueMachine/JuYueAction.h"
#endif
#endif
