#ifndef __JCWYTIEBUJI_H__
#define __JCWYTIEBUJI_H__

#if JIA_CHENG_WEI_YE_MACHINE

extern void TBJ_InitAction(void);
extern void TBJ_ManualAction(void);
extern void TBJ_Action(void);
extern void TBJ_DelayAction(void);


#define TBJ_ALARM_ADDR      100
#define TBJ_TOTAL_ADDR      0
#define TBJ_PROSPEED_ADDR   78


#define VAVLE_ALARM_TIME   3000
#define GUO_LIAN_OVER_TIME 10000

#define TBJ_DIR_P            0

//故障代码列表
#define TBJ_NO_ALARM         0
#define TBJ_TOTAL_ALARM      1
#define TBJ_KADAI_ALARM      2
#define TBJ_XIACHONG_ARRIVE_ALARM     3
#define TBJ_HM_LIMIT_ALARM            4
#define TBJ_SM_LIMIT_ALARM            5
#define TBJ_GUOLIAN_ALARM             6

#define TBJ_SongJiaoStep cStepMByte4
#define TBJ_HeMoStep     cStepMByte3
#define TBJ_ManualStep   cStepMByte2
#define TBJ_MotorStep    cStepMByte1
#define TBJ_AutoStep     cStepMByte

#define TBJ_HeMoDelay     cDelayTime1
#define TBJ_AutoDelay     cDelayTime2
#define TBJ_CQ_Delay      cDelayTime3
#define TBJ_SJ_Delay      cDelayTime4
#define TBJ_CS_Delay      cDelayTime5
#define TBJ_MotorDelay    cDelayTime6    

#define TBJ_PARAM_SET_TOTAL          (user_datas[2] |  user_datas[3] << 16) 
#define TBJ_PARAM_DELAY_CS           (user_datas[6] * 10)
#define TBJ_PARAM_CS_TIME            (user_datas[7] * 10)
#define TBJ_PARAM_COLD_TIME          (user_datas[8] * 10)
#define TBJ_PARAM_XMCQ_TIME          (user_datas[9] * 10)
#define TBJ_PARAM_DELAY_BACK_GZ_TIME (user_datas[10] * 10)
#define TBJ_PARAM_CQ_TIME          (user_datas[11] * 10)
#define TBJ_PARAM_DELAY_GZ           (user_datas[12] * 10)
#define TBJ_PARAM_HIGH_SPEED          user_datas[13]
#define TBJ_PARAM_LOW_SPEED           user_datas[14]
#define TBJ_PARAM_HM_DELAY           (0 * 10)
#define TBJ_PARAM_CYCLE_DELAY        (0 * 10)
#define TBJ_PARAM_LOWSPEED_LENGTH     user_datas[17]

#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]




#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)
#define TBJ_KaDai_IN  X02
#define TBJ_GUO_LIAN_IN X03
#define TBJ_GUO_LIAN_IN_UP (X03 && !OLDX03)
#define TBJ_GUO_LIAN_IN_DW (!X03 && OLDX03)
#define TBJ_GZ_IN       X04
#define TBJ_QD_LIMIT_IN X05
#define TBJ_SJ_LIMIT_IN X06
#define TBJ_SJ_ORIGIN_IN X07
#define TBJ_SM_LIMIT_IN  X10
#define TBJ_XM_LIMIT_IN  X11
#define TBJ_QJ_IN        X12

#define TBJ_GZ_VAVLE       Y02
#define TBJ_QDB_VAVLE      Y03
#define TBJ_JJ_VAVLE       Y04
#define TBJ_SJ_VAVLE       Y05
#define TBJ_SM_VAVLE       Y06
#define TBJ_XM_VAVLE       Y07
#define TBJ_CQ_VAVLE       Y10
#define TBJ_CS_OUT         Y11
#define TBJ_FJ_VAVLE       Y12
//M0~M4 Actioon.h全局使用


#define TBJ_bMotor         M0005
#define TBJ_bGouZhen       M0006
#define TBJ_bQianDao       M0007
#define TBJ_bJiaJiao       M0008
#define TBJ_bStart         M0009
#define TBJ_bSongJiao      M0010
#define TBJ_bHeMo          M0011
#define TBJ_bCS            M0012
#define TBJ_bChuiQi        M0013
#define TBJ_bRunning       M0017
#define TBJ_bStop          M0018
#define TBJ_bSM            M0019
#define TBJ_bXM            M0020
#define TBJ_bFenJiao       M0021
#define TBJ_bAlarmStop     M0036



#endif

#endif

