#ifndef __PWCJSKL_NILONG_STEP_JI_H__
#define __PWCJSKL_NILONG_STEP_JI_H__

#if PENG_WEI_CHANG_MACHINE

extern void JSKL_InitAction(void);
extern void JSKL_NiLongXiuCiJiAction(void);
extern void JSKL_ExtiActionX31(void);

#define JSKL_ALARM_ADDR   100
#define JSKL_TOTAL_ADDR 76
#define JSKL_PROSPEED_ADDR 78

#define JSKL_DIR_N 0
#define JSKL_DIR_P 1

#define JSKL_NO_ALARM        0
#define JSKL_FD_LIMIT_ALARM        1
#define JSKL_XM_LIMIT_ALARM        2
#define JSKL_PJ_LIMIT_ALARM        3
#define JSKL_PJ_ORIGIN_ALARM       4
#define JSKL_SM_LIMIT_ALARM        5
#define JSKL_XM_ORIGIN_ALARM       6
#define JSKL_GUOLIAN_ALARM         7
#define JSKL_TM_LEFT_ALARM              8
#define JSKL_TL_ALARM              9
#define JSKL_GZ_ALARM              10

#define JSKL_TOTAL_ALARM     11
#define JSKL_TM_RIGHT_ALARM   12
#define JSKL_VAVLE_ALARM_TIME    3000


#define JSKL_PARAM_HIGH_SPEED     user_datas[0]
#define JSKL_PARAM_LOW_SPEED      user_datas[1]
#define JSKL_PARAM_GZ_DELAY      (user_datas[2]*10)
#define JSKL_PARAM_STOP_DELAY     user_datas[3]
#define JSKL_PARAM_FD_DELAY      (user_datas[4]*10)
#define JSKL_PARAM_FZ_DELAY      (user_datas[5]*10)
#define JSKL_PARAM_PJ_DELAYBACK  (user_datas[6]*10)
#define JSKL_PARAM_FZ_LENGTH      user_datas[7]
#define JSKL_PARAM_DELAY_START   (user_datas[8]*10)
#define JSKL_PARAM_ZIPPER_TIME   (user_datas[9]*10)
#define JSKL_PARAM_TM_TIME       (user_datas[10]*10)
#define JSKL_PARAM_TM_TIMES       user_datas[11]
#define JSKL_PARAM_DELAY_FD_BACK  (user_datas[12]*10)
#define JSKL_PARAM_DELAY_TM_BACK  (user_datas[13]*10)
#define JSKL_PARAM_DELAY_ALL_BACK  user_datas[14]
#define JSKL_PARAM_SINGLE_MODE     user_datas[15]
#define JSKL_PARAM_ZDP_ENABLE      user_datas[16]
#define JSKL_PARAM_DELAY_FD_BACK2  (user_datas[17]*10)
#define JSKL_PARAM_DELAY_CHECK      user_datas[18]
#define JSKL_PARAM_PJ_DELAY        (user_datas[19]*10)
#define JSKL_PARAM_PJ_PUSH_LENGTH   user_datas[20]
#define JSKL_PARAM_FD_ENABLE      1//  user_datas[21]
#define JSKL_PARAM_FD_GO_LENGTH       user_datas[22] 
#define JSKL_PARAM_LEFT_ENABLE        user_datas[71]
#define JSKL_PARAM_RIGHT_ENABLE       user_datas[72]


#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]



#define JSKL_bClear          M0001
#define JSKL_bOnceStart      M0002
#define JSKL_bGZStart        M0003
#define JSKL_bStop           M0004
#define JSKL_bZDP            M0005
#define JSKL_bGZ             M0006
#define JSKL_bFD             M0008
#define JSKL_bXM             M0009
#define JSKL_bSM             M0010
#define JSKL_bTL             M0011
#define JSKL_bPJ             M0012
#define JSKL_bAlarmStop      M0013
#define JSKL_bLTM            M0014
#define JSKL_bRTM            M0016
#define JSKL_bMotor          M0017
#define JSKL_bStart          M0018

#define JSKL_cAutoStep          cStepMByte  
#define JSKL_cMotorStep         cStepMByte1
#define JSKL_cFDStep            cStepMByte2
#define JSKL_cCheckLStep         cStepMByte3
#define JSKL_cCheckRStep         cStepMByte4

#define JSKL_cAutoDelay         cDelayTime1
#define JSKL_cMotorDelay        cDelayTime2
#define JSKL_cFDDelay           cDelayTime3
#define JSKL_cTMDelay           cDelayTime4
#define JSKL_cCheckLDelay       cDelayTime5
#define JSKL_cCheckRDelay       cDelayTime6
#define JSKL_cFDBackDelay       cDelayTime7
#define JSKL_cGLCheckDelay      cDelayTime8
#define JSKL_cXiaChongDelay     cDelayTime9
#define JSKL_cXMDelay           cDelayTime10
#define JSKL_cPJDelay           cDelayTime11

#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)
#define JSKL_GuoLian_IN      X02
#define JSKL_GuoLian_IN_UP  (X02 && !OLDX02)
#define JSKL_GuoLian_IN_DW  (!X02 && OLDX02)
#define JSKL_GZ_ORIGIN_IN    X03
#define JSKL_GZ_ORIGIN_IN_DW (!X03 && OLDX03)
#define JSKL_GZ_IN           X04
#define JSKL_FD_IN           X05
#define JSKL_XM_LIMIT_IN     X06
#define JSKL_XM_LIMIT_IN_UP  (X06 && !OLDX06)
#define JSKL_XM_LIMIT_IN_DW  (!X06 && OLDX06)
#define JSKL_XM_ORIGIN_IN    X07
#define JSKL_XM_ORIGIN_IN_DW (!X07 && OLDX07)
#define JSKL_SM_LIMIT_IN     X10
#define JSKL_SM_LIMIT_IN_DW  (!X10 && OLDX10)
#define JSKL_PJ_LIMIT_IN     X11
#define JSKL_PJ_ORIGIN_IN    X12
#define JSKL_L_QL_IN         X13
#define JSKL_R_QL_IN         X14

#define JSKL_FMQ_OUT         Y00
#define JSKL_GZ_VAVLE        Y01
#define JSKL_FD_VAVLE        Y02
#define JSKL_XM_VAVLE        Y03
#define JSKL_SM_VAVLE        Y04        //ģ
#define JSKL_PJ_VAVLE        Y05
#define JSKL_LTM_VAVLE       Y06
#define JSKL_RTM_VAVLE       Y07

#define JSKL_ZDP_VAVLE       Y13
#define JSKL_SZ_OUT          Y14

#endif

#endif