#ifndef __TYDAKONG_H__
#define __TYDAKONG_H__

#if TONG_YONG_MACHINE | BRUCE_MACHINE

extern void DK_InitAction(void);
extern void DK_ManualAction(void);
extern void DK_Action(void);

#define DK_ALARM_ADDR      100
#define DK_TOTAL_ADDR      76
#define DK_ALLTOTAL_ADDR   79
#define DK_PROSPEED_ADDR   78


#define DK_VAVLE_ALARM_TIME   3000


#define DK_DIR_N            1
#define DK_DIR_P            0
//故障代码列表
#define DK_NO_ALARM         0
#define DK_TOTAL_ALARM      1
#define DK_GZ_ORIGIN_ALARM           2
#define DK_XIACHONG_ARRIVE_ALARM     3
#define DK_XM_LIMIT_ALARM            4
#define DK_SM_LIMIT_ALARM            5
#define DK_GUOLIAN_ALARM             6
#define DK_GZ_ALARM                  7
#define DK_START_GZ_ALARM            8
#define DK_START_YD_ALARM            9
#define DK_START_SM_ALARM            10
#define DK_START_XM_ALARM            11


#define DK_XiaChongStep cStepMByte3
#define DK_ManualStep   cStepMByte2
#define DK_MotorStep    cStepMByte1
#define DK_AutoStep     cStepMByte

#define DK_XiaChongDelay cDelayTime1
#define DK_AutoDelay     cDelayTime2
#define DK_CQ_Delay      cDelayTime4
#define DK_MotorDelay    cDelayTime5    

#define DK_PARAM_SET_TOTAL          (user_datas[2] |  user_datas[3] << 16) 
#define DK_PARAM_ZIPRER_LENGTH      (user_datas[4] |  user_datas[5] << 16)
#define DK_PARAM_XC_DELAY           (user_datas[6] * 10)
#define DK_PARAM_XC_ALARM_TIME      (user_datas[8] * 10)
#define DK_PARAM_XC_DELAY_STOP_TIME (user_datas[9] * 10)
#define DK_PARAM_HIGH_SPEED          user_datas[10] 
#define DK_PARAM_CYCLE_DELAY        (user_datas[11] * 10)
#define DK_PARAM_CYCLE_PULSE         user_datas[12]
#define DK_PARAM_CYCLE_LENGTH        user_datas[13]
#define DK_PARAM_BM_LINE             user_datas[14]
#define DK_PARAM_CQ_TIME             (user_datas[15]*10)
#define DK_PARAM_LOWSPEED_LENGTH     user_datas[16]
#define DK_PARAM_BACK_LENGTH         user_datas[17]
#define DK_PARAM_LOW_SPEED           user_datas[18]
#define DK_PARAM_XM_DELAY           (user_datas[19] * 10)
#define DK_PARAM_CS_ENABLE           user_datas[20]
#define DK_PARAM_GZ_DELAY           (user_datas[21] * 10)
#define DK_PARAM_DELAY_STOP_MOTOR    user_datas[22]
#define DK_PARAM_YD_DELAY           (user_datas[23] * 10)
#define DK_PARAM_SM_DELAY_BACK      (user_datas[24] * 10)
#define DK_PARAM_NO_ZIPPER_TIME     (user_datas[25] * 10)
#define DK_PARAM_GZ_DELAY_BACK      (user_datas[26] * 10)
#define DK_PARAM_SM_DELAY           (user_datas[27] * 10)
#define DK_PARAM_CS_DELAY           (user_datas[28] * 10)
#define DK_PARAM_CS_TIME            (user_datas[29] * 10)
#define DK_PARAM_CS_COLD_TIME       (user_datas[30] * 10)
#define DK_PARAM_XM_ENABLE           user_datas[31]
#define DK_PARAM_RUN_STATE           user_datas[250]
#define DK_PROSPEED                  user_datas[78]

#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]

#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)

#define DK_GZSwitch_IN      X02
#define DK_GZSwitch_IN_UP  (X02 && !OLDX02)
#define DK_GZSwitch_IN_DW  (!X02 && OLDX02)


#define DK_YDSwitch_IN      X03
#define DK_YDSwitch_IN_UP  (X03 && !OLDX03)
#define DK_YDSwitch_IN_DW  (!X03 && OLDX03)

#define DK_RJSwitch_IN      X04
#define DK_RJSwitch_IN_UP  (X04 && !OLDX04)

#define DK_ManAuto_IN      X05
#define DK_ManAuto_IN_UP  (X05 && !OLDX05)

#define DK_GZ_ORIGIN_IN    X06
#define DK_GuoLian_IN      X07
#define DK_GuoLian_IN_UP  (X07 && !OLDX07)

#define DK_GZ_IN           X10
#define DK_SM_LIMIT_IN     X11

#define DK_CSSwitch_IN     X12
#define DK_CSSwitch_IN_UP (X12 && !OLDX12)

#define DK_XM_LIMIT_IN     X13

#define DK_GZ_VAVLE       Y01
#define DK_CQ_VAVLE       Y02
#define DK_SM_VAVLE       Y03
#define DK_XM_VAVLE       Y04
#define DK_SZ_OUT         Y05
#define DK_CS_OUT         Y15


//M0~M4 Actioon.h全局使用


#define DK_bMotor         M0005
#define DK_bBackMotor     M0006
#define DK_bSM            M0007
#define DK_bManXiaChong   M0008
#define DK_bStart         M0009
#define DK_bGZ            M0010
#define DK_bCQ            M0011
#define DK_bRJ            M0012

#define DK_bSingle        M0020
#define DK_bXM            M0015

#define DK_bRunning       M0017
#define DK_bStop          M0018
#define DK_bAlarmStop     M0019



#endif

#endif

