#ifndef __TYTIEBUJI_H__
#define __TYTIEBUJI_H__

#if TONG_YONG_MACHINE | BRUCE_MACHINE
/**************************************

** 函数名称：
** 函数功能：
新款超声贴布机 C12
** 输入输出说明：
输入：
 /输入说明
//X000      起动  
//X001      停止
//X002      手动钩针
//X003      手动分胶
//X004      手动合模 
//X005      手动送胶
//X006      手动超声
//X007      自动位   (有屏的情况下为温控)
//X010      上超 
//X011      过链接近开关
//X012      前导板（分胶）前磁感
//X013      前导板（分胶）后磁感
//X014      下冲到位  
//X015      新款勾针复位，老款合模到位
//X016      送胶到位磁感
//X017      退胶到位磁感
//X020		拖带到位
//X021		缺胶信号

//输出说明
//Y000	    离合器	(也控制方向，1往前，0往后)
//Y001      勾针阀   
//Y002      导板阀（分胶） 
//Y003      下冲气缸	     
//Y004      送胶阀
//Y005      新款（压带阀）老款下模(发振部分)
//Y006      吹气（昌盛　吹气，鑫业　夹胶）	     
//Y007      计数
//Y010 　　 音波
//Y011		拖带电机（继电器)

D+   接驱动器的(MF+或EN+)信号
D-   接驱动器的(MF-或EN-)信号

P+		 接驱动器的(PULSE+)信号
P-		 接驱动器的(PULSE-)信号

P00		延时超声     0.06
P01		延时上勾针    010
P02　　	送胶到位延时返回   2
P03		压带输出    0
P04		延时分胶    0.03
P05     延时停离合（打孔型时二次定位）20
P06		超声时间    0.1
P07		固化时间    0.05
P08		吹气时间    0.2
P09		送胶时间（滚轮方式并且没有送胶前信号） 0.12
P10		电机起动速度  10
P11		电机加速度    10
P12		最高速度      40
P13	　　空位速度      8 


P14	　	送胶方式　0　气缸，1　滚轮
P15		下模方式　0　下模活动,1下模不动
P16		退勾针方式　　0　先超声后下勾针，1　先下勾针后超声
P17		双勾针选择    0  双勾针(新款)　　		1　单勾针
P18     二次拖带选择　0　普通拖带　　1　二次拖带()　
P19     滚轮送胶时到位信号是否有　0　有前限位　1 没前限位
P20     拖带电机定位后是否反转(步进型有效)　0　不反转　1 反转
P21     是否有导板阀（分胶阀)(0,有分胶阀，1没分胶阀)
P22     反转速度  10         
P24	　　拖带自动停机时间(防坏压轮胶)   10
P25	　　送胶完成后延时二次拖带   40 
P26     打孔型时一次定位时间     20
P27     电机反转脉冲    5
P28     温度到达超声时减少的时间（有屏状态才有效）  0
P29		自动测长度时自动允许拉带长度偏差（设0 无效） 0
P30     冷却时间 
P31     开模后延时拖带

P63     当用编码器时的编码使能，位0最上一个有效，位1中间一个有效，位2下面一个有效
P64     超声时间参数方式选择，0老款拔码，1编码,2内部按键设(或通信设定）
P65　　 接线方式（0　昌盛, 1 鑫业, 2 盈兴）
P66　　 拔码时间顺序（0　正常, 1 最后一组为超声时间）

***************************************/
extern void TBJ_InitAction(void);
extern void TBJ_ManualAction(void);
extern void TBJ_Action(void);
extern void TBJ_DelayAction(void);

#define ChangSheng      0	//昌盛代码
#define XinYe      		1	//鑫业代码
#define YinXin     		2	//鑫业代码
#define SongJiaoMode   	user_datas[14]		//送胶方式
#define XiaMoMode   	user_datas[15]		//下模方式
#define TuiGZMode   	user_datas[16]		//退勾针方式
#define SGZSelect   	user_datas[17]		//双勾针选择
#define TWOTDSelect   	user_datas[18]		//二次拖带选择
#define SongJiaoDaoWei 	user_datas[19]		//送胶时到位信号
#define DianJiFanZ	 	user_datas[20]		//电机是否反转
#define FengJiaoSelect 	user_datas[21]		//是否有分胶阀
#define CJSelect   		user_datas[65]		//厂家配置
#define BMSeq	  		user_datas[66]		//拔码时间顺序

//警告
#define NoZip_W   		1		//没拉链警告
#define TuiGZ_W   		2		//退勾针不到位警告
#define GZDaoWei_W		3		//勾针不到位警告
#define SongJiao_W		4		//送胶不到位
#define TuiJiao_W		5		//退胶不到位
#define TuiFenJiao_W	6		//退分胶不到位
#define NoJiao_W		7		//胶已用完
#define ZipperLengPRO_W	8	//拉链长度保护
#define Hemo_DaoWei_W	9	//合模到位
#define FenJiao_DaoWei_W	10		//分胶不到位

#define TBJ_ERRORTIME 2000



#endif

#endif

