#ifndef __XSDAKONG_H__
#define __XSDAKONG_H__

#if XIN_SHENG_MACHINE

extern void DK_InitAction(void);
extern void DK_ManualAction(void);
extern void DK_Action(void);
extern void DK_DelayAction(void);
extern void DK_ExtiActionX30(void);
extern void DK_ExtiActionX31(void);

#define DK_ALARM_ADDR      100
#define DK_TOTAL_ADDR      0
#define DK_PROSPEED_ADDR   78


#define VAVLE_ALARM_TIME   3000
#define GUO_LIAN_OVER_TIME 10000

#define DK_DIR_P            0

//故障代码列表
#define DK_NO_ALARM         0
#define DK_TOTAL_ALARM      1
#define DK_KADAI_ALARM      2
#define DK_XIACHONG_ARRIVE_ALARM     3
#define DK_XM_LIMIT_ALARM            4
#define DK_SM_LIMIT_ALARM            5
#define DK_GUOLIAN_ALARM             6


#define DK_XiaChongStep cStepMByte3
#define DK_ManualStep   cStepMByte2
#define DK_MotorStep    cStepMByte1
#define DK_AutoStep     cStepMByte

#define DK_XiaChongDelay cDelayTime1
#define DK_AutoDelay     cDelayTime2
#define DK_XMCQ_Delay    cDelayTime3
#define DK_FLCQ_Delay    cDelayTime4
#define DK_CS_Delay      cDelayTime5
#define DK_MotorDelay    cDelayTime6    

#define DK_PARAM_SET_TOTAL          (user_datas[2] |  user_datas[3] << 16) 
#define DK_PARAM_DELAY_CS           (user_datas[6] * 10)
#define DK_PARAM_CS_TIME            (user_datas[7] * 10)
#define DK_PARAM_COLD_TIME          (user_datas[8] * 10)
#define DK_PARAM_XMCQ_TIME          (user_datas[9] * 10)
#define DK_PARAM_DELAY_BACK_GZ_TIME (user_datas[10] * 10)
#define DK_PARAM_FLCQ_TIME          (user_datas[11] * 10)
#define DK_PARAM_DELAY_GZ           (user_datas[12] * 10)
#define DK_PARAM_HIGH_SPEED          user_datas[13]
#define DK_PARAM_LOW_SPEED           user_datas[14]
#define DK_PARAM_XC_DELAY            0
#define DK_PARAM_CYCLE_DELAY         0
#define DK_PARAM_LOWSPEED_LENGTH     user_datas[17]

#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]




#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)
#define DK_KaDai_IN  X02
#define DK_CD_UP_LIMIT_IN   X03
#define DK_CD_DOWN_LIMIT_IN X04
#define DK_GUO_LIAN_IN X05
#define DK_GUO_LIAN_IN_UP (X05 && !OLDX05)
#define DK_GUO_LIAN_IN_DW (!X05 && OLDX05)
#define DK_GZ_IN     X06
#define DK_GZ_UP_LIMIT_IN     X07
#define DK_GZ_DOWN_LIMIT_IN   X10
#define DK_XM_LIMIT_IN        X11
#define DK_SM_LIMIT_IN        X12

#define DK_GZ_VAVLE       Y00
#define DK_YD_VAVLE       Y01
#define DK_XM_VAVLE       Y02
#define DK_XMCQ_VAVLE     Y03
#define DK_SM_VAVLE       Y04
#define DK_FLCQ_VAVLE     Y05
#define DK_CS_OUT         Y06
#define DK_CD_MOTOR       Y07


//M0~M4 Actioon.h全局使用


#define DK_bMotor         M0005
#define DK_bGouZhen       M0006
#define DK_bYaDai         M0007
#define DK_bManXiaChong   M0008
#define DK_bStart         M0009
#define DK_bSM            M0010
#define DK_bXM            M0011
#define DK_bCS            M0012
#define DK_bXMCQ          M0013
#define DK_bFLCQ          M0014
#define DK_bChuDai        M0015

#define DK_bRunning       M0017
#define DK_bStop          M0018
#define DK_bAlarmStop    M0036



#endif

#endif

