#include "st_sys.h"
#include "st_dma.h"
static DMA_Stream_TypeDef * st_dma_steam_map[] = {
	DMA1_Channel1,
    DMA1_Channel2,
    DMA1_Channel3,
    DMA1_Channel4,
    DMA1_Channel5,
    DMA1_Channel6,
    DMA1_Channel7,
    DMA2_Channel1,
    DMA2_Channel2,
    DMA2_Channel3,
    DMA2_Channel4,
    DMA2_Channel5
};

/**
 * ʼDMA
 *
 * @author lxz
 */
void st_dma_init(void)
{
    //ʹDMA2 DMA1ʱ
    int index = 0;
    do
    {
        RCC->AHBENR|=3<<0;
    }while ((RCC->AHBENR & (0x03 << 0)) == 0);


    while(index <= ST_DMA2_STREAM5)
    {
        DMA_Stream_TypeDef *DMA_Streamx = st_dma_steam_map[index];
        DMA_Streamx->CCR = 0;
        DMA_Streamx->CNDTR = 0;
        DMA_Streamx->CPAR = 0;
        DMA_Streamx->CMAR = 0;
        index++;
    }
}

//DMAxĸͨ
//Ĵʽǹ̶,Ҫݲͬ޸
//Ӵ洢->ģʽ/8λݿ/洢ģʽ
//DMA_Streamx:DMA,DMA1_Stream0~7/DMA2_Stream0~7
//chx:DMAͨѡ,Χ:1~115(<<STM32H7xxοֲ>>16.3.2,Table 116)
//par:ַ
//mar:洢ַ
//ndtr:ݴ
void st_dma_config(uint8_t streamx,uint8_t chx,uint32_t par,uint32_t mar,uint16_t ndtr)
{
    DMA_Stream_TypeDef *DMA_Streamx;

    DMA_Streamx = st_dma_steam_map[streamx];




    DMA_Streamx->CPAR=par;       //DMAַ
    DMA_Streamx->CMAR=mar;      //DMA 洢0ַ
    DMA_Streamx->CNDTR=ndtr;     //DMA 洢0ַ
    DMA_Streamx->CCR=0;          //ȫλCRĴֵ

    DMA_Streamx->CCR|=1<<6;      //洢ģʽ
    DMA_Streamx->CCR|=0<<8;      //ѭģʽ(ʹͨģʽ)
    DMA_Streamx->CCR|=0<<9;      //ģʽ
    DMA_Streamx->CCR|=1<<10;     //洢ģʽ
    DMA_Streamx->CCR|=0<<11;     //ݳ:8λ
    DMA_Streamx->CCR|=0<<13;     //洢ݳ:8λ
    DMA_Streamx->CCR|=1<<16;     //еȼ
    DMA_Streamx->CCR|=0<<21;     //ͻδ
    DMA_Streamx->CCR|=0<<23;     //洢ͻδ
    DMA_Streamx->CCR |= chx << 25;

    //DMA_Streamx->FCR=0X21;    //FIFOƼĴ
}
//һDMA
//DMA_Streamx:DMA,DMA1_Stream0~7/DMA2_Stream0~7
//ndtr:ݴ
void st_dma_enable(uint8_t streamx,uint16_t ndtr)
{
    DMA_Stream_TypeDef *DMA_Streamx = st_dma_steam_map[streamx];
    DMA_Streamx->CCR&=~(1<<0);   //رDMA
    while(DMA_Streamx->CCR&0X1); //ȷDMAԱ
    DMA_Streamx->CNDTR=ndtr;     //DMA 洢0ַ
    DMA_Streamx->CCR|=1<<0;      //DMA
}

/**
 * ֹͣDMA
 *
 * @author lxz
 *
 * @param streamx
 */
void st_dma_disable(uint8_t streamx)
{
    st_dma_steam_map[streamx]->CCR &= ~(1 << 0);
}

/**
 * ȡDMAʵָ
 *
 * @author lxz
 *
 * @param streamx
 *
 * @return void*
 */
void * st_dma_get_stream(uint8_t streamx)
{
    SW_WAIT_FINISH(streamx > ST_DMA2_STREAM5);
    return st_dma_steam_map[streamx];
}

/**
 * ȡDMAͨڵDMA
 *
 * @author lxz
 *
 * @param streamx
 *
 * @return void*
 */
void * st_dma_get_dmax(uint8_t streamx)
{
    SW_WAIT_FINISH(streamx > ST_DMA2_STREAM5);
    if(streamx > ST_DMA1_STREAM7)
    {
        return DMA2;
    }
    return DMA1;
}

/**
 * жͨǷʹ
 *
 * @author lxz
 *
 * @param streamx
 *
 * @return void*
 */
int st_dma_is_enable(uint8_t streamx)
{
   return (((DMA_Stream_TypeDef *)st_dma_get_stream(streamx))->CCR & 0x0001);
}























